# -*- coding: utf-8 -*-
## ExternalSiteCatalog
## Index and search external sites in a Plone site
## Copyright (C)2006 Ingeniweb

## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
## (at your option) any later version.

## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.

## You should have received a copy of the GNU General Public License
## along with this program; see the file COPYING. If not, write to the
## Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
"""
The ExternalSiteCatalog module
Zope factory registration

$Id: __init__.py,v 1.14 2006/05/23 09:48:28 roeder Exp $
"""
__docformat__ = 'restructuredtext'

# CMF imports
from Products.CMFCore import DirectoryView
from Products.CMFCore.utils import ContentInit, ToolInit

# Archetypes imports
from Products.Archetypes.public import process_types, listTypes

# Products imports
from Products.ExternalSiteCatalog.config import GLOBALS
from Products.ExternalSiteCatalog.tool import ExternalSiteCatalog
import Products.ExternalSiteCatalog.content

# Register skin directories so they can be added to portal_skins
DirectoryView.registerDirectory('skins', GLOBALS)

from Products.ExternalSiteCatalog.config import GLOBALS, PROJECTNAME

from Products.ExternalSiteCatalog.content import ExternalSiteCatalogTask

def initialize(context):
    # initialize the content, including types and add permissions
    content_types, constructors, ftis = process_types(
        listTypes(PROJECTNAME),
        PROJECTNAME)

    # Initialize the tool
    ToolInit(
        PROJECTNAME + ' Tool',
        tools=(ExternalSiteCatalog,),
        icon='tool.gif').initialize(context)

    # Assign an own permission to all content types
    # Heavily based on Bricolite's code from Ben Saller
    from Products.ExternalSiteCatalog.permission import permissions
    
    allTypes = zip(content_types, constructors)
    for atype, constructor in allTypes:
        kind = "%s: %s" % (PROJECTNAME, atype.archetype_name)
        ContentInit(
            kind,
            content_types      = (atype,),
            permission         = permissions[atype.portal_type],
            extra_constructors = (constructor,),
            fti                = ftis,
            ).initialize(context)

    ContentInit(
        'MaintenanceTask (ExternalSiteCatalog)',
        content_types = (ExternalSiteCatalogTask.ExternalSiteCatalogTask,),
        permission = permissions['ExternalSiteCatalogTask'],
        extra_constructors = (ExternalSiteCatalogTask.addExternalSiteCatalogTask,),
        fti = (ExternalSiteCatalogTask.factory_type_information,),
        ).initialize(context)
